﻿Contributing to Mobius
========================
This page outlines contribution to Mobius

Ways to contribute
------------------
If you would like to become involved in the development of Mobius, there are many different ways in which you can contribute. We strongly value your feedback, questions, bug reports, and feature requests.

Consider these options:
* Use Mobius bits
* Submit a GitHub issue (see [Issue Guide](../docs/project-docs/issue-guide.md)).
* Verify fixes for bugs.
* Submit a code fix for a bug.
* Submit a new feature request (as a GitHub issue in [Issue Guide](../docs/project-docs/issue-guide.md)).
* Help answer questions on Mobius mailing lists (*[sparkclr-user](https://groups.google.com/d/forum/sparkclr-user)* or *[sparkclr-dev](https://groups.google.com/d/forum/sparkclr-dev)*).
* Submit a unit test.
* Code review pending pull requests and bug fixes.
* Tell others about Mobius.

Contributing Code Changes
-------------------------

If you are looking for something to work on, the list of [up-for-grabs issues](https://github.com/Microsoft/Mobius/labels/up%20for%20grabs) is a good starting point.

Before opening a *pull request*, review [Contributing Code Changes](../docs/project-docs/CONTRIBUTING.md).
It lists steps that are required before creating a PR. In particular, consider:

- Is the change important and ready enough to ask the community to spend time reviewing?
- Have you searched for existing, related issues and pull requests?
- Is the change being proposed clearly explained and motivated?

Contribution License Agreement
------------------------------
We appreciate community contributions to code repositories open sourced by Microsoft. By signing a
[contribution license agreement](https://cla.microsoft.com/cladoc/microsoft-contribution-license-agreement.pdf), we ensure that the community is free to use your contributions.

When a contributor makes a pull request, the Microsoft Pull Request BOT (MSBOT) checks whether the change requires a CLA; for example, trivial typo fixes usually don’t require a CLA. If no CLA is required, the pull request is labeled as *cla-not-required* and the contributor is done. If the change requires a CLA, MSBOT checks whether the contributor has already signed one; if you have, the pull request is labeled as *cla-signed* and the contributor is done. If the contributor needs to sign a CLA, MSBOT will label the request as *cla-required* and post a comment pointing you to sign in on the appropriate website to sign the CLA (fully electronic, no faxing involved); once the contributor has signed a CLA, the pull request is labeled as *cla-signed*. You are done.

We accept only pull requests that are labeled as either *cla-not-required*, *cla-signed* or *cla-already-signed*.

=========================
**Credit** to [Microsoft Azure](http://azure.github.io/guidelines.html) and [Apache Spark](https://github.com/apache/spark/blob/master/CONTRIBUTING.md). We are borrowing liberally from their processes.
